<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cyhal__interconnect_8h" kind="file" language="C++">
    <compoundname>cyhal_interconnect.h</compoundname>
    <includes local="no">stdint.h</includes>
    <includes local="no">stdbool.h</includes>
    <includes local="yes" refid="cy__result_8h">cy_result.h</includes>
    <includes local="yes" refid="cyhal__hw__types_8h">cyhal_hw_types.h</includes>
    <includedby local="yes" refid="cyhal__drivers_8h">cyhal_drivers.h</includedby>
    <includedby local="yes" refid="cyhal__interconnect_8c">cyhal_interconnect.c</includedby>
    <includedby local="yes" refid="cyhal__not__implemented_8c">cyhal_not_implemented.c</includedby>
    <includedby local="yes" refid="cyhal__qspi_8c">cyhal_qspi.c</includedby>
    <includedby local="yes" refid="cyhal__utils_8c">cyhal_utils.c</includedby>
    <incdepgraph>
      <node id="164">
        <label>stdbool.h</label>
      </node>
      <node id="163">
        <label>stdint.h</label>
      </node>
      <node id="162">
        <label>cyhal_interconnect.h</label>
        <link refid="cyhal__interconnect_8h" />
        <childnode refid="163" relation="include">
        </childnode>
        <childnode refid="164" relation="include">
        </childnode>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__results__interconnect_1ga06e2a17327bc70766baaa7444effbf2d" kind="define" prot="public" static="no">
        <name>CYHAL_CONNECT_RSLT_NO_CONNECTION</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005ab9373b6613ccb00bd4dedab0ae06d11c">CYHAL_RSLT_MODULE_INTERCONNECT</ref>, 0))</initializer>
        <briefdescription>
<para>No connection is available. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" bodystart="73" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="73" />
      </memberdef>
      <memberdef id="group__group__hal__results__interconnect_1gae531065e9aa44a0bbb5f4945186125de" kind="define" prot="public" static="no">
        <name>CYHAL_CONNECT_RSLT_ALREADY_CONNECTED</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005ab9373b6613ccb00bd4dedab0ae06d11c">CYHAL_RSLT_MODULE_INTERCONNECT</ref>, 1))</initializer>
        <briefdescription>
<para>The connections source and destination are already connected. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" bodystart="76" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="76" />
      </memberdef>
      <memberdef id="group__group__hal__results__interconnect_1gacbf273b2e176cfaf0a6fa8e02f23a602" kind="define" prot="public" static="no">
        <name>CYHAL_CONNECT_RSLT_INVALID_TRIGGER_CONNECTION</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005ab9373b6613ccb00bd4dedab0ae06d11c">CYHAL_RSLT_MODULE_INTERCONNECT</ref>, 2))</initializer>
        <briefdescription>
<para>Invalid trigger connection. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" bodystart="79" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="79" />
      </memberdef>
      <memberdef id="group__group__hal__interconnect_1gaffe612e67138b9f3185fafaf81f40a2d" kind="define" prot="public" static="no">
        <name>CYHAL_INTERCONNECT_MUX_NOT_CONTINUATION</name>
        <initializer>0xFF</initializer>
        <briefdescription>
<para>Indicates that a mux output does not continue to another mux. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" bodystart="87" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="87" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__interconnect_1gaeb7156c33f00a7c21867a46e401d59ef" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_connect_pin</definition>
        <argsstring>(const cyhal_resource_pin_mapping_t *pin_connection)</argsstring>
        <name>cyhal_connect_pin</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref> *</type>
          <declname>pin_connection</declname>
        </param>
        <briefdescription>
<para>Connect a pin to a peripheral terminal. </para>        </briefdescription>
        <detaileddescription>
<para>This will route a direct connection from the pin to the peripheral. Any previous direct connection from the pin will be overriden.<linebreak />
 See <ref kindref="member" refid="group__group__hal__interconnect_1subsection_interconnect_snippet1">Snippet 1: Connecting a pin to TCPWM block</ref> <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">pin_connection</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin and target peripheral terminal to be connected </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the connect request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="95" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__interconnect_1ga62898739384ebb41a8b3e2c4d491a0cc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_disconnect_pin</definition>
        <argsstring>(cyhal_gpio_t pin)</argsstring>
        <name>cyhal_disconnect_pin</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin</declname>
        </param>
        <briefdescription>
<para>Disconnect a peripheral from a pin. </para>        </briefdescription>
        <detaileddescription>
<para>This will also reset the pin's drive mode to High-Z. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">pin</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to be disconnected </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the disconnect request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="101" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__interconnect_1gab686907d86a19472f1abb56788227f9a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_connect_trigger</definition>
        <argsstring>(cyhal_source_t source, cyhal_dest_t dest)</argsstring>
        <name>cyhal_connect_trigger</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__hw__types_1gae6e4ea4100036d96d2efc006a3f69c9b">cyhal_source_t</ref></type>
          <declname>source</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__triggers__psoc6__01_1gaa2df0778261ace69282e18e3ec39553c">cyhal_dest_t</ref></type>
          <declname>dest</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;WORK IN PROGRESS. This function is not yet fully implemented.&lt;br /&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Connects two digital terminals on the device using any internal interconnect. A single source can drive multiple destinations, but a destination can be driven by only one source. If the destination is already connected, or the connection can not be established an error will be returned. </verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">source</parametername>
</parameternamelist>
<parameterdescription>
<para>The source of the signal to connect </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dest</parametername>
</parameternamelist>
<parameterdescription>
<para>The destination of the signal to connect </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the connect request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="217" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_not_implemented.c" bodystart="145" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" line="113" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides a high level interface for interacting with the internal digital routing on the chip. </para>    </briefdescription>
    <detaileddescription>
<para>This interface abstracts out the chip specific details. If any chip specific functionality is necessary, or performance is critical the low level functions can be used directly.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="55"><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdint.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdbool.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_result.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="60"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_hw_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="64"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="preprocessor">#define<sp />CYHAL_CONNECT_RSLT_NO_CONNECTION<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="74"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_INTERCONNECT,<sp />0))</highlight><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="preprocessor">#define<sp />CYHAL_CONNECT_RSLT_ALREADY_CONNECTED<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="77"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_INTERCONNECT,<sp />1))</highlight><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="preprocessor">#define<sp />CYHAL_CONNECT_RSLT_INVALID_TRIGGER_CONNECTION<sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="80"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_INTERCONNECT,<sp />2))</highlight><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal" /></codeline>
<codeline lineno="87"><highlight class="preprocessor">#define<sp />CYHAL_INTERCONNECT_MUX_NOT_CONTINUATION<sp />0xFF</highlight><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal" /></codeline>
<codeline lineno="95"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__interconnect_1gaeb7156c33f00a7c21867a46e401d59ef">cyhal_connect_pin</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref><sp />*pin_connection);</highlight></codeline>
<codeline lineno="96"><highlight class="normal" /></codeline>
<codeline lineno="101"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__interconnect_1ga62898739384ebb41a8b3e2c4d491a0cc">cyhal_disconnect_pin</ref>(<ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin);</highlight></codeline>
<codeline lineno="102"><highlight class="normal" /></codeline>
<codeline lineno="113"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__interconnect_1gab686907d86a19472f1abb56788227f9a">cyhal_connect_trigger</ref>(<ref kindref="member" refid="group__group__hal__impl__hw__types_1gae6e4ea4100036d96d2efc006a3f69c9b">cyhal_source_t</ref><sp />source,<sp /><ref kindref="member" refid="group__group__hal__impl__triggers__psoc6__01_1gaa2df0778261ace69282e18e3ec39553c">cyhal_dest_t</ref><sp />dest);</highlight></codeline>
<codeline lineno="114"><highlight class="normal" /></codeline>
<codeline lineno="115"><highlight class="normal" /></codeline>
<codeline lineno="116"><highlight class="normal" /></codeline>
<codeline lineno="117"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal">}</highlight></codeline>
<codeline lineno="119"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="120"><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />CYHAL_INTERCONNECT_IMPL_HEADER</highlight><highlight class="normal" /></codeline>
<codeline lineno="122"><highlight class="normal" /><highlight class="preprocessor">#include<sp />CYHAL_INTERCONNECT_IMPL_HEADER</highlight><highlight class="normal" /></codeline>
<codeline lineno="123"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CYHAL_INTERCONNECT_IMPL_HEADER<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_interconnect.h" />
  </compounddef>
</doxygen>